

class classifier1():
    """
    Naive Bayes class implementation
    """
    def __init__(self):
        self.lowSalaryPrior = None
        self.highSalaryPrior = None
        self.education_table = None
        self.salary_table = None
        self.workclass_table = None
        
        
    def fit(self, X, Y):
        """
        Naive Bayes training method.
        input X: pandas data frame of feature values. To extract a feature: E.g.: training.loc[:,['education']]
        input Y: pandas series of output values. E.g.: training['salary']
        """
        
        # start with the a-priori probabilities
        self.salary_table = Y.value_counts()
        
        # p(<=50K)
        self.lowSalaryPrior = float(salary_table.loc['<=50K'].astype('float')/salary_table.sum())
        
        # p(>50K)
        self.highSalaryPrior = float(salary_table.loc['>50K'].astype('float')/salary_table.sum())
        
        # Education
        self.education_table = pd.crosstab(X['education'], Y)
        
        # Workclass
        self.workclass_table = pd.crosstab(X['workclass'], Y)
    
    
    def predict(self, x, printScores = True):
        """
        Naive Bayes predicting function
        input x: vector of features corresponding to a row of a pandas data frame
        """
        lowSalaryScore = self.lowSalaryPrior
        highSalaryScore = self.highSalaryPrior
        
        # education feature
        education = x['education']
        workclass = x['workclass']
        
        
        if education != '?':
            # TODO: use data in education_table to compute new scores for
            #   lowSalaryScore and highSalaryScore
            #
            # Hints:
            #    number of observations for a particular education value, and for a salary of <=50K: self.education_table.loc[education, '<=50K'].astype('float')
            #    Number of people earning <= 50K: self.salary_table.loc['<=50K']
            #    Convert your final likelihood to float using float(...)
            likelihood_educationlowSalary = float(self.education_table.loc[education, '<=50K'].astype('float') / self.salary_table.loc['<=50K'])
            likelihood_educationhighSalary = float(self.education_table.loc[education, '>50K'].astype('float') / self.salary_table.loc['>50K'])
        
            lowSalaryScore = lowSalaryScore * likelihood_educationlowSalary
            highSalaryScore = highSalaryScore * likelihood_educationhighSalary
        
        if workclass != '?':
        # workclass
            # TODO: use data in workclass_table to compute new scores for
            #   lowSalaryScore and highSalaryScore
            #
            # Hints:
            #    number of observations for a particular workclass value, and for a salary of <=50K: self.education_table.loc[education, '<=50K'].astype('float')
            #    Number of people earning <= 50K: self.salary_table.loc['<=50K']
            #    Convert your final likelihood to float using float(...)
            likelihood_workclasslowSalary = float(self.workclass_table.loc[workclass, '<=50K'].astype('float') / self.salary_table.loc['<=50K'])
            likelihood_workclasshighSalary = float(self.workclass_table.loc[workclass, '>50K'].astype('float') / self.salary_table.loc['>50K'])
        
            lowSalaryScore = lowSalaryScore * likelihood_workclasslowSalary
            highSalaryScore = highSalaryScore * likelihood_workclasshighSalary
        
        if printScores:
            print("<=50K: {}, >50K: {}".format(lowSalaryScore, highSalaryScore))
        
        # Return prediction
        # TODO: Add score weights here
        result = '<=50K' if lowSalaryScore>=highSalaryScore else '>50K'
        
        return(result)
        


        


        
        

